% This function solves the bananaf non-linear equation problem using
% fsolve, where the Jacobian is generated by adigatorGenFiles4Fsolve
%
% Copyright 2011-2014 Matthew J. Weinstein and Anil V. Rao
% Distributed under the GNU General Public License version 3.0
clear all
clc
n = 2^8;
xstart = rand(n,1);
solveflag = exist('fsolve','file');

% ----------------------- Solve with 1st Derivatives -------------------- %
% setup structure for adigatorGenFiles4Fsolve
setup.numvar = n;
setup.function = 'bananaf';
% Call adigatorGenFiles4Fsolve
tic
adifuncs = adigatorGenFiles4Fsolve(setup);
gentime = toc;

odds  = 1:2:n;
evens = 2:2:n;
z0 = zeros(n,1);
z0(odds) = -1.9; z0(evens) = 2;

% Call fsolve
if solveflag
  options = optimoptions(@fsolve,'Display','iter','Jacobian','on');
  [x,F,exitflag,output,JAC] = fsolve(adifuncs.jacobian,z0,options);
end